<?php
/**
 * Cobub Razor huawei_plugin
 *
 * An open source analytics for mobile applications
 *
 * @package		Cobub Razor
 * @author		WBTECH Dev Team
 * @copyright	Copyright (c) 2011 - 2012, NanJing Western Bridge Co.,Ltd.
 * @license		http://www.cobub.com/products/cobub-razor/license
 * @link		http://www.cobub.com/products/cobub-razor/
 * @since		Version 1.0
 * @filesource
 */
class Applist extends CI_Controller {
	
	function __construct() {
		parent::__construct ();
		$this->load->helper ( array (
				'form',
				'url' 
		) );
		$this->load->language ( 'plugin_huawei' );
		$this->load->library ( 'form_validation' );
		$this->load->Model ( 'common' );
		$this->load->Model ( 'plugin/huawei/applistmodel', 'huaweimodel' );
		$this->common->requireLogin ();
	
	}
	
	function index() {
		
		$this->common->loadHeader ( lang ( 'huawei_homepage' ) );
		$arr = $this->huaweimodel->getProductInfo ();
		$userId = $this->common->getUserId ();
		$userKeys = $this->huaweimodel->getUserKeys ( $userId );
		
		if ($userKeys) {
			$this->data ["applist"] = $this->huaweimodel->assoc_unique ( $arr, 'androidlist' );
			$this->data ['isAuth'] = 1;
			$this->data ['flag'] = $this->getUserStatus ();
		} else {
			$this->data ['isAuth'] = 0;
			$this->data ['msgw'] = lang ( 'plg_get_keysecret' );
			$this->data ['flag'] = $this->getUserStatus ();
			$this->data ["applist"] = $this->huaweimodel->assoc_unique ( $arr, 'androidlist' );
		}
		$this->load->view ( 'plugin/huawei/applistview', $this->data );
	}
	
	function getapplist()
	{
		$arr = $this->huaweimodel->getProductInfo ();
		$userId = $this->common->getUserId ();
		$userKeys = $this->huaweimodel->getUserKeys ( $userId );
		
		if ($userKeys) {
			$data ["applist"] = $this->huaweimodel->assoc_unique ( $arr, 'androidlist' );
			$data ['listAuth'] = 1;
			$data ['listflag'] = $this->getUserStatus ();
		} else {
			$data ['listAuth'] = 0;
			$data ['listflag'] = $this->getUserStatus ();
			$data ["applist"] = $this->huaweimodel->assoc_unique ( $arr, 'androidlist' );
		}
		
		echo json_encode($data);
		
	}
	
	function getUserStatus() {
		$userId = $this->common->getUserId ();
		$userKeys = $this->huaweimodel->getUserKeys ( $userId );
		if ($userKeys) {
			$data = array (
					'userKey' => $userKeys->user_key,
					'userSecret' => $userKeys->user_secret 
			);
			$url = SERVER_BASE_URL . "/index.php?/api/igetui/getUserActive";
			$response = $this->common->curl_post ( $url, $data );
			$obj = json_decode ( $response, true );
			
			$flag = $obj ['flag'];
		} else {
			$flag = 0;
		}
		
		return $flag;
	}
	
	function pushInfo() {
		$appName = $_GET ['appName'];
		$productid = $_GET ['productID'];
		$type = $_GET ['type'];
		
		$data = $this->huaweimodel->checkInfoPush ( $appName, $productid );
		$flag = $this->getUserStatus ();
		
		if ($data) {
			$userId = $this->common->getUserId ();
			$userKeys = $this->huaweimodel->getUserKeys ( $userId );
			$data ['userKey'] = $userKeys->user_key;
			$data ['userSecret'] = $userKeys->user_secret;
			$data ['isAuth'] = 1;

			redirect ( site_url () . "/tag/tags?product_id=" . $data ['productId'] . "&url=" . site_url () . "/plugin/huawei/huaweicl" );
		
		} else {
			
			$data ['flag'] = $flag;
			$data ['msg'] = lang ( 'v_warningInfo' );
			$data ['isAuth'] = 1;
			$arr = $this->huaweimodel->getProductInfo ();
			$data ["applist"] = $this->huaweimodel->assoc_unique ( $arr, 'androidlist' );
			$this->common->loadHeader ( lang ( 'huawei_homepage' ) );
			$this->load->view ( 'plugin/huawei/applistview', $data );
		}
	
	}

}
