<?php
/**
 * Cobub Razor Huawei_plugin
 *
 * An open source analytics for mobile applications
 *
 * @package		Cobub Razor
 * @author		WBTECH Dev Team
 * @copyright	Copyright (c) 2011 - 2012, NanJing Western Bridge Co.,Ltd.
 * @license		http://www.cobub.com/products/cobub-razor/license
 * @link		http://www.cobub.com/products/cobub-razor/
 * @since		Version 1.0
 * @filesource
 */
class Huaweiactivate extends CI_Controller {
	
	function __construct() {
		parent::__construct ();
		$this->load->helper ( array (
				'form',
				'url' 
		) );
		$this->load->language('plugin_huawei');
		$this->load->library ( 'form_validation' );
		$this->load->Model ( 'common' );
		$this->common->requireLogin ();
		$this->load->Model ( 'plugin/huawei/activatemodel', 'huaweimodel');
		$this->load->Model ( 'plugin/huawei/applistmodel', 'hwapplistmodel');
		
		$this -> load -> model('channelmodel', 'channel');
		$this -> load -> Model('user/ums_user');
	
	}
	
	function index() {
		$appName = $_GET ['appName'];
		$productID = $_GET ['productID'];	
		$this->data ['appName'] = $appName;
		$this->data ['productID'] = $productID;
		
		$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productID);
		
		if($this->data ['description'] && strlen($this->data ['description'])<100)
		{
			$this->data ['descstrlen']=1;
		}
		
		$this -> data['parenttype'] = $this -> huaweimodel -> getparenttype();
		$this -> data['category'] = $this -> ums_user -> getproductCategories();
		
		$this->common->loadHeader ( lang ( 'v_activateApp' ) );	
		$this->load->view ( 'plugin/huawei/activateview', $this->data );
	}
	
	function uploadchildtype() {
		
 		$parenttype = $_POST['parent'];
 		$channel = $this -> huaweimodel -> getchildtype($parenttype);
 		echo json_encode($channel);
	}
	
	function uploadgrandchildtype() {
	
		$parenttype = $_POST['parent'];
		$childtype = $_POST['child'];
		$grandapptype = $this -> huaweimodel -> getgrandchildtype($parenttype,$childtype);
		echo json_encode($grandapptype);
	}
	
	function activateApp() {
	
		$userId = $this->common->getUserId ();
		$userKeys = $this->huaweimodel->getUserKeys ( $userId );
		$this->data ['userKey'] = $userKeys->user_key;
		$this->data ['userSecret'] = $userKeys->user_secret;
		
		$this->form_validation->set_rules ( 'packagename', 'PackageName', 'trim|required|xss_clean' );
		
		$appName = $this->input->post ( "appname" );
		$productid = $this->input->post ( "productid" );
		$appPackagename = $this->input->post ( "packagename" );
		
		$description = $this -> huaweimodel ->getProductDescription($productid);
		if($description && strlen($description)<100)
		{
			$description = $this->input->post ( "description" );
			if($description && strlen($description)>100)
			{
				$this -> hwapplistmodel->updateProductDescription($productid,$description);
				$description = $this -> huaweimodel ->getProductDescription($productid);
			}
		}
		////error data
		$this->data ['appName'] = $appName;
		$this->data ['productID'] = $productid;
		$this->data ['description'] = $description;
		$this->data['parenttype'] = $this -> huaweimodel -> getparenttype();
		
		////send to ucenter
		$this->appdata ['appCnName'] = $appName;
		$this->appdata ['appCnDesc'] = $description;
		$this->appdata ['packageName'] = $appPackagename;
		$this->appdata ['user_id'] = $userId;
		$this->appdata ['userKey'] = $userKeys->user_key;
		$this->appdata ['userSecret'] = $userKeys->user_secret;
		
		//print_r($this->appdata);
		if(!preg_match("/^[0-9a-zA-Z]+([.])+([0-9a-zA-Z]+)/",$appPackagename ))
		{
			$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productid);
			$this->data ['appName'] = $appName;
			$this->data ['packagenametips'] = lang('huawei_app_enter_packagename');
			$this->common->loadHeader ( lang ( 'v_activateApp' ) );
			$this->load->view ( 'plugin/huawei/activateview', $this->data );
			return;
		}
		if(strlen($description)<101)
		{
			$this->data ['description'] =$description;// $this -> huaweimodel ->getProductDescription($productid);
			$this->data ['appName'] = $appName;
			$this->data ['msg'] = lang('huawei_app_info_nolength');
			$this->common->loadHeader ( lang ( 'v_activateApp' ) );
			$this->load->view ( 'plugin/huawei/activateview', $this->data );
			return;
		}
		
		if ($this->form_validation->run ()) {
		
			$url_active = SERVER_BASE_URL."/index.php?/plugins/hwapp/addApp";
			$response = $this->common->curl_post ( $url_active, $this->appdata );
			$obj = json_decode ( $response, true );
			$flag = $obj ['code'];

			//response infomation can not be null, or activate failure
			if($flag < 0){
				
				$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productid);
				$this->data ['appName'] = $appName;
				$this->data ['msg'] = lang('huawei_app_active_failed').$obj['desc'];
				$this->common->loadHeader ( lang ( 'v_activateApp' ) );
				$this->load->view ( 'plugin/huawei/activateview', $this->data );
			}else {
				
				$this->responseArray ['flag'] = $flag;
				$this->responseArray ['appName'] = $obj ['app_info']['app_cn_name'];
				$this->responseArray ['packageName'] = $obj ['app_info']['package_name'];
				$this->responseArray ['description'] = $obj ['app_info']['app_cn_desc'];
				
				$this->responseArray ['developerUpdTime'] = $obj ['app_info']['developer_upd_time'];
				$this->responseArray ['userId'] = $obj ['app_info']['cobub_user_id'];
				$this->responseArray ['appType'] = $obj ['app_info']['app_type'];
				$this->responseArray ['status'] = $obj ['app_info']['work_order_state']+2;
				$this->responseArray ['productID'] = $productid;
				$this->responseArray ['languages'] = $obj ['app_info']['languages'];
				
				////save app's status change 
				print_r($this->responseArray);
				if ($this->responseArray ['packageName'] && $this->huaweimodel->saveUsersInfo ( $this->responseArray )) 
				{
					$this->common->loadHeader ( lang ( 'v_keysInfo' ) );
					$this->load->view ( 'plugin/huawei/activateview', $this->responseArray );
				} 
				else {
					$this->data ['msg'] = lang ( 'huawei_app_warning_actived' );
					$this->common->loadHeader ( lang ( 'v_activateApp' ) );
					$this->load->view ( 'plugin/huawei/activateview', $this->data );
				}
			
			} 
		
		} else {
			$this->data ['msg'] = lang ( 'huawei_app_warningInfo' );
			$this->common->loadHeader ( lang ( 'v_activateApp' ) );
			$this->load->view ( 'plugin/huawei/activateview', $this->data );
		}
	}
	
	function submitApp() {
		$appName = $_GET ['appName'];
		$productID = $_GET ['productID'];
		$datainfo = $this->hwapplistmodel->getappinfo ($productID);

		$this->data['app_name'] = $datainfo[0]['app_name'];
		$this->data['app_id'] = $datainfo[0]['app_id'];
		$this->data['product_id'] = $datainfo[0]['product_id'];
		$this->data['work_id'] = $datainfo[0]['work_id'];
		$this->data['package_name'] = $datainfo[0]['package_name'];
		$this->data['create_time'] = $datainfo[0]['create_time'];
		
		$this->data['app_type'] = "androidapp";
		$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productID);
		
		$this->common->loadHeader( );
		$this->load->view ( 'plugin/huawei/appsubmitview', $this->data );
	}
	
	function onSubmitApp() {

		$appName = $this->input->post ( "appname" );
		$productID = $this->input->post ( "productid" );
		$appID = $this->input->post ( "appID" );
		$workID = $this->input->post ( "workID" );
		$createtime = $this->input->post ( "createtime" );
		$apptype = $this->input->post ( "apptype" );
		$appPackagename = $this->input->post ( "packagename" );
		$datainfo = $this->hwapplistmodel->getappinfo ($productID);
		
		if(!empty($datainfo))
		{
			$this->appdata['app_id'] = $datainfo[0]['app_id'];
			$this->appdata['work_order_id'] = $datainfo[0]['work_id'];
			
			if($datainfo[0]['status'] == 1)
			{
				$url_active = SERVER_BASE_URL."/index.php?/plugins/hwapp/submitApp";
				$response = $this->common->curl_post ( $url_active, $this->appdata );
				$obj = json_decode ( $response, true );
				$flag = $obj ['code'];

				if($flag>0)
				{
					$updateinfo =array('appID'=>$this->appdata['app_id']);
					$this->huaweimodel->updateAppinfo($updateinfo);
					$this->data['flag'] = 1;
					$this->data['msg'] = lang('huawei_app_submit_successed');
				}
				else
				{
					$this->data['msg'] = lang('huawei_app_submit_failed');
				}
			}
			else {
				$this->data['flag'] = 2;
			}

			$this->data['app_name'] = $datainfo[0]['app_name'];
			$this->data['app_id'] = $datainfo[0]['app_id'];
			$this->data['product_id'] = $datainfo[0]['product_id'];
			$this->data['work_id'] = $datainfo[0]['work_id'];
			$this->data['package_name'] = $datainfo[0]['package_name'];
			$this->data['create_time'] = $datainfo[0]['create_time'];
			$this->data['app_type'] = "androidapp";
			
		}
		else {
			$this->data['app_name'] =$appName;
			$this->data['app_id'] = $appID;
			$this->data['product_id'] = $productID;
			$this->data['work_id'] = $workID;
			$this->data['package_name'] = $appPackagename;
			$this->data['create_time'] = $createtime;
			$this->data['app_type'] = $apptype;
			$this->data['msg'] = lang('huawei_app_submit_datebase_error');
			
		}

		$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productID);
		$this->common->loadHeader();
		$this->load->view ( 'plugin/huawei/appsubmitview', $this->data );
	}
	
	function checkInfo() {
		$appName = $_GET ['appName'];
		$productID = $_GET ['productID'];
		$this->data = $this->huaweimodel->checkInfo ($appName, $productID );
		
		$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productID);
		
		$this->common->loadHeader ( );
		$this->load->view ( 'plugin/huawei/activateview', $this->data );
	}
		
	// //huawei check application
	function oncheck() {
		$appName = $_GET ['appName'];
		$productID = $_GET ['productID'];
		
		$datainfo = $this->hwapplistmodel->getappinfo ( $productID );
		if (empty ( $datainfo )) {
			$this->appdata ['appID'] = $datainfo [0] ['app_id'];
			$this->appdata ['workID'] = $datainfo [0] ['work_id'];
			
			$url_active = SERVER_BASE_URL . "/index.php?/hwapp/app/submitApp";
			$response = $this->common->curl_post ( $url_active, $this->appdata );
			$obj = json_decode ( $response, true );
			$flag = $obj ['flag'];
			
			$this->huaweimodel->updateAppinfo($obj);
			
			$this->data = $this->huaweimodel->checkInfo ( $appName, $productID );
			
			$this->data ['description'] = $this->huaweimodel->getProductDescription ( $productID );
			
			$this->common->loadHeader ();
			$this->load->view ( 'plugin/huawei/activateview', $this->data );
		}
	}
	
	////修改包名
	function changename()
	{
		$appName = $_GET ['appName'];
		$productID = $_GET ['productID'];
		$this->data ['appName'] = $appName;
		$this->data ['productID'] = $productID;
		$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productID);
		
		$this->data ['descstrlen']=1;
		
		$this->data ['packageName'] = $this -> huaweimodel ->getPackageName($productID);
		print_r($this->data ['packageName']);
		
		$this -> data['parenttype'] = $this -> huaweimodel -> getparenttype();
		$this -> data['category'] = $this -> ums_user -> getproductCategories();
		
		$this->common->loadHeader ( lang ( 'huawei_change_name' ) );
		$this->load->view ( 'plugin/huawei/changenameview', $this->data );
	}
	
	function changeApp() {
	
		$userId = $this->common->getUserId ();
		$userKeys = $this->huaweimodel->getUserKeys ( $userId );
		$this->data ['userKey'] = $userKeys->user_key;
		$this->data ['userSecret'] = $userKeys->user_secret;
	
		$this->form_validation->set_rules ( 'packagename', 'PackageName', 'trim|required|xss_clean' );
	
		$appName = $this->input->post ( "appname" );
		$productid = $this->input->post ( "productid" );
		$appPackagename = $this->input->post ( "packagename" );
	
		$description = $this -> huaweimodel ->getProductDescription($productid);
		if($description && strlen($description)<100)
		{
			$description = $this->input->post ( "description" );
			if($description && strlen($description)>100)
			{
				$this -> hwapplistmodel->updateProductDescription($productid,$description);
				$description = $this -> huaweimodel ->getProductDescription($productid);
			}
		}
		////error data
		$this->data ['appName'] = $appName;
		$this->data ['productID'] = $productid;
		$this->data ['description'] = $description;
		$this->data['parenttype'] = $this -> huaweimodel -> getparenttype();
	
		////send to ucenter
		$this->appdata ['appCnName'] = $appName;
		$this->appdata ['appCnDesc'] = $description;
		$this->appdata ['packageName'] = $appPackagename;
		$this->appdata ['user_id'] = $userId;
		$this->appdata ['userKey'] = $userKeys->user_key;
		$this->appdata ['userSecret'] = $userKeys->user_secret;
	
		//print_r($this->appdata);
		if(!preg_match("/^[0-9a-zA-Z]+([.])+([0-9a-zA-Z]+)/",$appPackagename ))
		{
			$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productid);
			$this->data ['appName'] = $appName;
			$this->data ['packagenametips'] = lang('huawei_app_enter_packagename');
			$this->common->loadHeader ( lang ( 'huawei_change_name' ) );
			$this->load->view ( 'plugin/huawei/changenameview', $this->data );
			return;
		}
		if(strlen($description)<101)
		{
			$this->data ['description'] =$description;// $this -> huaweimodel ->getProductDescription($productid);
			$this->data ['appName'] = $appName;
			$this->data ['msg'] = lang('huawei_app_info_nolength');
			$this->common->loadHeader ( lang ( 'huawei_change_name' ) );
			$this->load->view ( 'plugin/huawei/changenameview', $this->data );
			return;
		}
	
		if ($this->form_validation->run ()) {
	
			$url_active = SERVER_BASE_URL."/index.php?/plugins/hwapp/addApp";
			$response = $this->common->curl_post ( $url_active, $this->appdata );
			$obj = json_decode ( $response, true );
			$flag = $obj ['code'];
	
			//response infomation can not be null, or activate failure
			if($flag < 0){
	
				$this->data ['description'] = $this -> huaweimodel ->getProductDescription($productid);
				$this->data ['appName'] = $appName;
				$this->data['packageName'] = $appPackagename;
				$this->data ['msg'] = lang('huawei_change_package_name_failed').$obj['desc'];
				$this->common->loadHeader ( lang ( 'huawei_change_name' ) );
				$this->load->view ( 'plugin/huawei/changenameview', $this->data );
			}else {
	
				$this->responseArray ['flag'] = $flag;
				$this->responseArray ['appName'] = $obj ['app_info']['app_cn_name'];
				$this->responseArray ['packageName'] = $obj ['app_info']['package_name'];
				$this->responseArray ['description'] = $obj ['app_info']['app_cn_desc'];
	
				$this->responseArray ['developerUpdTime'] = $obj ['app_info']['developer_upd_time'];
				$this->responseArray ['userId'] = $obj ['app_info']['cobub_user_id'];
				$this->responseArray ['appType'] = $obj ['app_info']['app_type'];
				$this->responseArray ['status'] = $obj ['app_info']['work_order_state']+2;
				$this->responseArray ['productID'] = $productid;
				$this->responseArray ['languages'] = $obj ['app_info']['languages'];
	
				////save app's status change
				//print_r($this->responseArray);
				if ($this->responseArray ['packageName'] && $this->huaweimodel->updatePackage ( $this->responseArray ))
				{
					$this->common->loadHeader ( lang ( 'v_keysInfo' ) );
					$this->load->view ( 'plugin/huawei/changenameview', $this->responseArray );
				}
				else {
					$this->data ['msg'] = lang ( 'huawei_app_warning_actived' );
					$this->common->loadHeader ( lang ( 'huawei_change_name' ) );
					$this->load->view ( 'plugin/huawei/changenameview', $this->data );
				}
					
			}
	
		} else {
			$this->data ['msg'] = lang ( 'huawei_app_warningInfo' );
			$this->common->loadHeader ( lang ( 'v_activateApp' ) );
			$this->load->view ( 'plugin/huawei/changenameview', $this->data );
		}
	}
	
	
}


