<?php
class Report extends CI_Controller {
	
	var $appid;
	var $gProductid;

	function __construct() {
		parent::__construct ();
		$this->load->language ( 'plugin_huawei' );
		$this->load->Model ( 'common' );
		$this->load->Model('plugin/huawei/applistmodel','hwmodel');
		$this->common->requireLogin ();
	}
	
	function index() {

		$productid = $_GET ['id'];
		$gProductid = $productid;
		$data = array ();
		$data ['appid'] = $productid;
		$packagename = $this->hwmodel->getPackageName($productid);
		$data ['packagename'] = $packagename;
		
		$fromTime = $this->common->getFromTime ();
		$toTime = $this->common->getToTime ();
		$days= abs(strtotime($toTime) - strtotime($fromTime))/60/60/24+1;
		if($days>31){
			$data['timeerror']=lang('time_chose_error');
		}
		$uid=$this->common->getUserId();
		$userinfo = $this->hwmodel->getUserinfo($uid);
		$userKey = $userinfo[0]['user_key'];
		$userSecret = $userinfo[0]['user_secret'];
		$data['user_key']=$userKey;
		$data['user_secret']=$userSecret;

		//获取推送记录
		$datareport ['packagename'] =$packagename;
		$pushrecords = $this->common->curl_post(SERVER_BASE_URL."/index.php?/api/huawei/getHwRecord",$datareport);
		$pushrecordsResult = json_decode($pushrecords);
		if(isset($pushrecordsResult->flag)){
			if($pushrecordsResult->flag>0){
				$data['fourrecords']=$pushrecordsResult->records;
			}
		}
		////获取用户报表
		$datauser['packagename'] = $packagename;
		$datauserrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getUserreport",$datauser);
		$arruser =json_decode($datauserrecords);
		if(isset($arruser->flag))
		{
			if($arruser->flag > 0 )
				$data['userrecords'] = $arruser->records;
		}
		
		////获取消息数报表
		$datamsg['packagename'] = $packagename;
		$datamsgrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getMessagereport",$datamsg);
		$arrmsg =json_decode($datamsgrecords);
		if(isset($arrmsg->flag))
		{
			if($arrmsg->flag > 0 )
				$data['msgrecords'] = $arrmsg->records;
		}

		$fromTime = $this -> common -> getFromTime();
		$toTime = $this -> common -> getToTime();
		$data['reportTitle'] = array('timePase' => getTimePhaseStr($fromTime, $toTime), 'UserReport' => "用户数趋势图", 'MsgReport' => "消息数趋势图");
		
		$this->common->loadHeaderWithDateControl ( lang ( 'huawei_data' ) );
		$this->load->view ( 'plugin/huawei/report',$data);
	}
	
	////推送记录
	function getRecords(){	
		$data = array ();
		$productid = $_GET ['appid'];
		$data ['packagename'] = $this->hwmodel->getPackageName($productid);
		$pushrecords = $this->common->curl_post(SERVER_BASE_URL."/index.php?/api/huawei/getHwRecord",$data);
		$arr =json_decode($pushrecords);
		$arr->appid=$_GET['appid'];
		echo json_encode($arr);
	}
	
	////推送详细记录
	function getrecorddata(){
		$recordid = $_GET['recordid'];
		$appid = $_GET['appid'];
		
		$data = array ();
		$uid=$this->common->getUserId();
		$userinfo = $this->hwmodel->getUserinfo($uid);
		$data['recordid']=$recordid;
		$records= $this->common->curl_post(SERVER_BASE_URL."/index.php?/api/huawei/getDetailRecord",$data);
		$result = json_decode($records);
		if(isset($result->flag)){
			if($result->flag > 0){
				$data['detailrecords'] = $result->records;
			}
		}
		$this->common->loadHeader('详细推送记录');
		$this->load->view ( 'plugin/huawei/reportdetail', $data );
	}
	
	function getDetailrecord()
	{
		$data['recordid'] = $_GET['recordid'];
		$records= $this->common->curl_post(SERVER_BASE_URL."/index.php?/api/huawei/getDetailRecord",$data);
		$arr =json_decode($records);
		$arr->recordid=$_GET['recordid'];
		echo json_encode($arr);
	}
	////number of user report
	function getUserReport()
	{
		$data['packagename'] = "com.huawei.aaach";//$_GET['packagename'];
		$userrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getUserreport",$data);
		$arr =json_decode($userrecords);
		echo json_encode($arr);
		
	}
	////number of message report  
	function getMessageReport()
	{
		$data['packagename'] = "com.huawei.aaach";//$_GET['packagename'];
		$msgrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getMessagereport",$data);
		$arr =json_decode($msgrecords);
		echo json_encode($arr);
	}
	
	function getData()
	{
		$type =$_GET['type'];
		$data['packagename'] = $_GET['packagename'];
		$data['start'] = $this->common->getFromTime ();
		$data['end'] = $this->common->getToTime ();
		if($type == 'userreport')
		{
			$userrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getUserRData",$data);
			$arr =json_decode($userrecords);
			echo json_encode($arr);
		}
		if($type == 'msgreport')
		{
			$msgrecords= $this->common->curl_post(SERVER_BASE_URL."/index.php?/plugins/hwreport/getMsgRData",$data);
			$arr =json_decode($msgrecords);
			echo json_encode($arr);
		}
	}

}
